find_CCS = function(samples, prob_level, threshold, type, M) {
    
    # type = 1 is thresholded correlation matrix
    # type = 2 is likelihood ratio score
    
    out = screened(samples, threshold)
    samples = out$screened_samples
    prob = out$prob
    
    if ( type == 1 ) {
        thresh = seq(from = 0.95, to = 0.01, length = 199)
    } else {
        thresh = 1:dim(samples)[2]
    }
    storesize = numeric(length(thresh))
    storeDP = numeric(length(thresh))
    lograt = numeric(length(thresh))
    
   
    if ( type == 1 ) {
        check = 0
        count = 0
        while ( check == 0 ) {
            count = count + 1
            print(count)

            out = find_cred_sets_MCMC2(samples, thresh[count], prob_level)
            nodeToComponent = out$nodeToComponent
            Conf_Set = out$Conf_Set
            prob_set = out$prob_set
            set_size = out$set_size
            Corr1 = out$Corr1
            Cov1 = out$Cov1
    
            for (i in 1:length(Conf_Set)) {
                storesize[count] = storesize[count] + log(dim(Conf_Set[[1, i]])[1])
                storeDP[count] = storeDP[count] + log(M) + lgamma(sum(nodeToComponent == i))
            }
            lograt[count] = storesize[count] + storeDP[count]
    
            print("here")
    
            if (lograt[count] > 1.2 * min(lograt[1:count])) {
                check = 1
            } else if (count == length(thresh)) {
                check = 1
            }
        }
        lograt = lograt[1:count]
        thresh = thresh[1:count]
        
        m1 = min(lograt)
        count = which(lograt == m1)[1]
    
        out = find_cred_sets_MCMC2(samples, thresh[count], prob_level)
        nodeToComponent = out$nodeToComponent
        Conf_Set = out$Conf_Set
        prob_set = out$prob_set
        set_size = out$set_size
        Corr1 = out$Corr1
        Cov1 = out$Cov1
    } else {
    
        out = find_cred_sets_MCMC3(samples, count, prob_level)
        nodeToComponent = out$nodeToComponent
        Conf_Set = out$Conf_Set
        prob_set = out$prob_set
        lograt = out$lograt
        thresh = out$thresh
    
        m1 = min(lograt)
        count = which(lograt == m1)[1]
    
        Conf_Set = Conf_Set[[count, 1]]
        prob_set = prob_set[[count, 1]]
        nodeToComponent = nodeToComponent[[count, 1]]
    }
    
    list(thresh = thresh, lograt = lograt, nodeToComponent = nodeToComponent, Conf_Set = Conf_Set, prob_set = prob_set)
}
